package cmdLogin

import (
	"syscall"

	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/nexush/utils"
	"golang.org/x/term"
)

type Login struct {
	Name string
}

func (cmd *Login) GetName() string {
	return cmd.Name
}

func (cmd *Login) GetDesc() []string {
	return []string{
		"Log in and obtain an access token."}
}

func (cmd *Login) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: " + cmd.Name + " email")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
}

func (cmd *Login) Run(client *nc.NexusClient, args []string) int {
	if len(args) != 1 {
		cmd.PrintUsage()
		return 1
	}

	email := args[0]

	u.PrintErr(email + "'s password: ")
	bytePwd, err := term.ReadPassword(int(syscall.Stdin))
	u.PrintlnErr("")
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}
	pwd := string(bytePwd)

	token, err := client.Authenticate(email, pwd)
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}

	u.Println(token)

	return 0
}
