package cmdTemplate

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/nexush/utils"
)

type Del struct {
	Name string
}

func (cmd *Del) GetName() string {
	return cmd.Name
}

func (cmd *Del) GetDesc() []string {
	return []string{
		"Deletes a template.",
		"Requires TPL_DESTROY or TPL_DESTROY_ANY user capability."}
}

func (cmd *Del) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: ", cmd.GetName(), " ID")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("ID      ID of the template to delete.")
}

func (cmd *Del) Run(client *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc != 1 {
		cmd.PrintUsage()
		return 1
	}

	tplID := args[0]
	err := client.TemplateDel(tplID)
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}

	u.Println("Template \"" + tplID + "\" successfully deleted")
	return 0
}
